<template>
  <g>
    <rect
      :width="end - start + TIMELINE_PADDING * 2"
      height="20"
      :x="start - TIMELINE_PADDING"
      :y="y"
      fill="#00000004"
    />
    <timeline-marker
      v-for="(marker, index) in timeMarkers"
      :key="index"
      :y="y + 14"
      :position="marker.position"
      :label="marker.label"
      :zoom="zoom"
    />
  </g>
</template>

<script lang="ts">
import type {
  Onset, Pixel, Rect, Signature, Unit,
} from '@/data';
import {
  Component, Prop, Watch,
} from 'vue-property-decorator';
import CanvasTimelineGeneric from './CanvasTimelineGeneric.vue';

@Component
export default class CanvasTimelineMusical extends CanvasTimelineGeneric {
  declare y: number;

  declare width: Pixel;

  declare zoom: number;

  declare pixelUnit: Unit<Pixel>;

  declare viewRect: Rect;

  @Prop({ required: true })
  signature!: Signature;

  TIMELINE_PADDING = 50;

  VISIBLE_MARKER = 6;

  timeMarkers: Array<{position: Pixel, label: string}> = [];

  end: Pixel = 0 as Pixel;

  interval = 1;

  @Watch('width')
  @Watch('viewRect.width')
  calculateVisibleInterval() {
    const interval = this.pixelUnit
      .toInterval(this.viewRect.x as Pixel, this.viewRect.x + this.viewRect.width as Pixel);
    this.interval = Math
      .ceil(interval.duration / (this.VISIBLE_MARKER * 4));
    if (this.interval < 1) this.interval = 1;
    this.calculatePositions(this.width);
  }

  @Watch('width')
  calculatePositions(newWidth: Pixel) {
    this.end = newWidth;
    const lastMeasure = this.signature.getMeasureFromOnset(this.pixelUnit.toOnset(newWidth).value);
    const newMarkers = [];
    for (let i = 1; i <= lastMeasure; i += this.interval) {
      const parsedOnset = this.signature.measureToOnset(`${i}`);

      const label = this.signature.printOnset(parsedOnset);
      if (/^\d+$/.test(label)) {
        newMarkers.push({
          position: this.pixelUnit.fromOnset(parsedOnset).value,
          label: this.signature.printOnset(parsedOnset),
        });
      } else {
        newMarkers.push({
          position: this.pixelUnit.fromOnset(parsedOnset).value,
          label: '·',
        });
      }

      for (let j = 0; j < this.interval; j += 1) {
        const currentOnset = this.signature.measureToOnset(`${i + j}`);

        if (j > 0) {
          newMarkers.push({
            position: this.pixelUnit.fromOnset(currentOnset).value,
            label: '|',
          });
        }

        const nextMeasure = this.signature.measureToOnset(`${i + j + 1}`);
        for (let k = currentOnset + 1; k < nextMeasure; k = k + 1 as Onset) {
          newMarkers.push({
            position: this.pixelUnit.fromOnset(k as Onset).value,
            label: '·',
          });
        }
      }
    }
    this.timeMarkers = [...newMarkers];
  }

  mounted() {
    this.calculateVisibleInterval();
  }
}
</script>
